## fpga-icestorm 0~20250207git7fbf8c0+dfsg1

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?=
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = source
BUILDDIR      = build
PYTHON		  ?= python3

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: clean

clean:
	@$(SPHINXBUILD) -M clean "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: reqs
reqs:
	$(PYTHON) -m pip install -r source/requirements.txt

=== icebox/Makefile ===
include ../config.mk

ifneq ($(shell uname -s),Darwin)
  SED_I = sed -i
else
  SED_I = sed -i ''
endif

all: chipdb-384.txt chipdb-1k.txt chipdb-8k.txt chipdb-5k.txt chipdb-lm4k.txt chipdb-u4k.txt

chipdb-384.txt: icebox.py iceboxdb.py icebox_chipdb.py
	$(PYTHON3) icebox_chipdb.py -3 > chipdb-384.new
	mv chipdb-384.new chipdb-384.txt

chipdb-1k.txt: icebox.py iceboxdb.py icebox_chipdb.py
	$(PYTHON3) icebox_chipdb.py > chipdb-1k.new
	mv chipdb-1k.new chipdb-1k.txt

chipdb-5k.txt: icebox.py iceboxdb.py icebox_chipdb.py
	$(PYTHON3) icebox_chipdb.py -5 > chipdb-5k.new
	mv chipdb-5k.new chipdb-5k.txt

chipdb-u4k.txt: icebox.py iceboxdb.py icebox_chipdb.py
	$(PYTHON3) icebox_chipdb.py -u > chipdb-u4k.new
	mv chipdb-u4k.new chipdb-u4k.txt

chipdb-lm4k.txt: icebox.py iceboxdb.py icebox_chipdb.py
	$(PYTHON3) icebox_chipdb.py -4 > chipdb-lm4k.new
	mv chipdb-lm4k.new chipdb-lm4k.txt

chipdb-8k.txt: icebox.py iceboxdb.py icebox_chipdb.py
	$(PYTHON3) icebox_chipdb.py -8 > chipdb-8k.new
	mv chipdb-8k.new chipdb-8k.txt

check: all
	$(PYTHON3) tc_xlat_netnames.py
	$(PYTHON3) tc_rxlat_netnames.py
	$(PYTHON3) tc_logic_xpr.py

clean:
	rm -f chipdb-1k.txt chipdb-8k.txt chipdb-384.txt chipdb-5k.txt chipdb-lm4k.txt chipdb-u4k.txt
	rm -f icebox.pyc iceboxdb.pyc

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp chipdb-384.txt    $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox/
	cp chipdb-1k.txt     $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox/
	cp chipdb-8k.txt     $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox/
	cp chipdb-5k.txt     $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox/
	cp chipdb-u4k.txt    $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox/
	cp chipdb-lm4k.txt   $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox/
	cp icebox.py         $(DESTDIR)$(PREFIX)/bin/$(subst -,_,$(PROGRAM_PREFIX))icebox.py
	cp iceboxdb.py       $(DESTDIR)$(PREFIX)/bin/$(subst -,_,$(PROGRAM_PREFIX))iceboxdb.py
	cp icebox_chipdb.py  $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_chipdb$(PY_EXE)
	cp icebox_diff.py    $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_diff$(PY_EXE)
	cp icebox_explain.py $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_explain$(PY_EXE)
	cp icebox_asc2hlc.py $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_asc2hlc$(PY_EXE)
	cp icebox_hlc2asc.py $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_hlc2asc$(PY_EXE)
	cp icebox_colbuf.py  $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_colbuf$(PY_EXE)
	cp icebox_html.py    $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_html$(PY_EXE)
	cp icebox_maps.py    $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_maps$(PY_EXE)
	cp icebox_vlog.py    $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_vlog$(PY_EXE)
	cp icebox_stat.py    $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_stat$(PY_EXE)
	$(SED_I) 's+import iceboxdb+import $(subst -,_,$(PROGRAM_PREFIX))iceboxdb as iceboxdb+g' $(DESTDIR)$(PREFIX)/bin/$(subst -,_,$(PROGRAM_PREFIX))icebox.py
	$(SED_I) 's+import icebox+import $(subst -,_,$(PROGRAM_PREFIX))icebox as icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_chipdb$(PY_EXE)
	$(SED_I) 's+import icebox+import $(subst -,_,$(PROGRAM_PREFIX))icebox as icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_diff$(PY_EXE)
	$(SED_I) 's+from icebox+from $(subst -,_,$(PROGRAM_PREFIX))icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_diff$(PY_EXE)
	$(SED_I) 's+import icebox+import $(subst -,_,$(PROGRAM_PREFIX))icebox as icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_explain$(PY_EXE)
	$(SED_I) 's+from icebox+from $(subst -,_,$(PROGRAM_PREFIX))icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_explain$(PY_EXE)
	$(SED_I) 's+import icebox+import $(subst -,_,$(PROGRAM_PREFIX))icebox as icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_asc2hlc$(PY_EXE)
	$(SED_I) 's+from icebox+from $(subst -,_,$(PROGRAM_PREFIX))icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_asc2hlc$(PY_EXE)
	$(SED_I) 's+import icebox+import $(subst -,_,$(PROGRAM_PREFIX))icebox as icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_hlc2asc$(PY_EXE)
	$(SED_I) 's+from icebox+from $(subst -,_,$(PROGRAM_PREFIX))icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_hlc2asc$(PY_EXE)
	$(SED_I) 's+import icebox+import $(subst -,_,$(PROGRAM_PREFIX))icebox as icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_colbuf$(PY_EXE)
	$(SED_I) 's+from icebox+from $(subst -,_,$(PROGRAM_PREFIX))icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_colbuf$(PY_EXE)
	$(SED_I) 's+import icebox+import $(subst -,_,$(PROGRAM_PREFIX))icebox as icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_html$(PY_EXE)
	$(SED_I) 's+from icebox+from $(subst -,_,$(PROGRAM_PREFIX))icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_html$(PY_EXE)
	$(SED_I) 's+import icebox+import $(subst -,_,$(PROGRAM_PREFIX))icebox as icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_maps$(PY_EXE)
	$(SED_I) 's+from icebox+from $(subst -,_,$(PROGRAM_PREFIX))icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_maps$(PY_EXE)
	$(SED_I) 's+import icebox+import $(subst -,_,$(PROGRAM_PREFIX))icebox as icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_vlog$(PY_EXE)
	$(SED_I) 's+from icebox+from $(subst -,_,$(PROGRAM_PREFIX))icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_vlog$(PY_EXE)
	$(SED_I) 's+/usr/local/share/icebox+$(PREFIX)/share/$(PROGRAM_PREFIX)icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_vlog$(PY_EXE)
	$(SED_I) 's+import icebox+import $(subst -,_,$(PROGRAM_PREFIX))icebox as icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_stat$(PY_EXE)
	$(SED_I) 's+from icebox+from $(subst -,_,$(PROGRAM_PREFIX))icebox+g' $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_stat$(PY_EXE)

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/$(subst -,_,$(PROGRAM_PREFIX))cebox.py
	rm -f $(DESTDIR)$(PREFIX)/bin/$(subst -,_,$(PROGRAM_PREFIX))iceboxdb.py
	rm -f $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_chipdb$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_diff$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_explain$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_asc2hlc$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_hlc2asc$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_colbuf$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_html$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_maps$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_vlog$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icebox_stat$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox/chipdb-384.txt
	rm -f $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox/chipdb-1k.txt
	rm -f $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox/chipdb-8k.txt
	rm -f $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox/chipdb-lm4k.txt
	rm -f $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox/chipdb-u4k.txt
	-rmdir $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox

.PHONY: all check clean install uninstall

=== icemulti/Makefile ===
include ../config.mk

ifeq ($(STATIC),1)
LDFLAGS += -static
endif

all: $(PROGRAM_PREFIX)icemulti$(EXE)

$(PROGRAM_PREFIX)icemulti$(EXE): icemulti.o
	$(CXX) -o $@ $(LDFLAGS) $^ $(LDLIBS)

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp $(PROGRAM_PREFIX)icemulti$(EXE) $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icemulti$(EXE)

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icemulti$(EXE)

clean:
	rm -f $(PROGRAM_PREFIX)icemulti$(EXE)
	rm -f $(PROGRAM_PREFIX)icemulti.exe
	rm -f *.o *.d

-include *.d

.PHONY: all install uninstall clean

=== icetime/Makefile ===
include ../config.mk
LDLIBS = -lm -lstdc++
override CXXFLAGS += -DPREFIX='"$(PREFIX)"' -DCHIPDB_SUBDIR='"$(CHIPDB_SUBDIR)"'

ifeq ($(STATIC),1)
LDFLAGS += -static
endif

all: $(PROGRAM_PREFIX)icetime$(EXE)

CHIPS=lp384 lp1k lp8k hx1k hx8k up5k u4k

ifeq ($(EXE),.js)
$(PROGRAM_PREFIX)icetime$(EXE): | share/$(CHIPDB_SUBDIR)/chipdb-384.txt share/$(CHIPDB_SUBDIR)/chipdb-1k.txt share/$(CHIPDB_SUBDIR)/chipdb-8k.txt share/$(CHIPDB_SUBDIR)/chipdb-5k.txt

share/$(CHIPDB_SUBDIR)/chipdb-384.txt: ../icebox/chipdb-384.txt
	mkdir -p share/$(CHIPDB_SUBDIR)
	cp $< $@
share/$(CHIPDB_SUBDIR)/chipdb-1k.txt: ../icebox/chipdb-1k.txt
	mkdir -p share/$(CHIPDB_SUBDIR)
	cp $< $@
share/$(CHIPDB_SUBDIR)/chipdb-8k.txt: ../icebox/chipdb-8k.txt
	mkdir -p share/$(CHIPDB_SUBDIR)
	cp $< $@
share/$(CHIPDB_SUBDIR)/chipdb-5k.txt: ../icebox/chipdb-5k.txt
	mkdir -p share/$(CHIPDB_SUBDIR)
	cp $< $@
override LDFLAGS += --embed-file share
endif

$(PROGRAM_PREFIX)icetime$(EXE): icetime.o iceutil.o $(addsuffix .o, $(addprefix timings-, $(CHIPS)))
	$(CXX) -o $@ $(LDFLAGS) $^ $(LDLIBS)

timings-%.cc: timings.py ../icefuzz/timings_%.txt
	$(PYTHON3) timings.py $* > $@

.PRECIOUS: timings-%.cc

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	mkdir -p $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox
	cp $(PROGRAM_PREFIX)icetime$(EXE) $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icetime$(EXE)
	cp ../icefuzz/timings_*.txt $(DESTDIR)$(PREFIX)/share/$(PROGRAM_PREFIX)icebox/

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/$(PROGRAM_PREFIX)icetime$(EXE)


# View timing netlist:
#  yosys -qp 'read_verilog -lib cells.v; prep; show' test0_ref.v
#  yosys -qp 'read_verilog -lib cells.v; prep; show' test0_out.v

test0 test1 test2 test3 test4 test5 test6 test7 test8 test9: icetime
	test -f $@_ref.v || $(PYTHON3) mktest.py $@
	./icetime -m -d hx1k -P tq144 -p $@.pcf -o $@_out.v $@.asc
	yosys $@.ys

run0 run1 run2 run3 run4 run5 run6 run7 run8 run9: icetime
	./icetime -t -d hx1k -P tq144 -p $(subst run,test,$@).pcf $(subst run,test,$@).asc

show0 show1 show2 show3 show4 show5 show6 show7 show8 show9: icetime
	bash show.sh $(subst show,test,$@)
	xdot $(subst show,test,$@).dot

test: test0 test1 test2 test3 test4 test5 test6 test7 test8 test9

show: show0 show1 show2 show3 show4 show5 show6 show7 show8 show9

clean:
	rm -f $(PROGRAM_PREFIX)icetime$(EXE) $(PROGRAM_PREFIX)icetime.exe *.o *.d timings-*.cc
	rm -rf test[0-9]*

-include *.d

.PHONY: all install uninstall clean

=== docs/source/requirements.txt ===
sphinx
sphinx_rtd_theme

=== examples/hx8kboard/Makefile ===
PROJ = example
PIN_DEF = hx8kboard.pcf
DEVICE = hx8k
PACKAGE = ct256

all: $(PROJ).rpt $(PROJ).bin

%.json: %.v
	yosys -p 'synth_ice40 -top top -json $@' $<

%.asc: $(PIN_DEF) %.json
	nextpnr-ice40 --$(DEVICE) --package $(PACKAGE) --asc $@ --pcf $< --json $*.json

%.bin: %.asc
	icepack $< $@

%.rpt: %.asc
	icetime -d $(DEVICE) -mtr $@ $<

prog: $(PROJ).bin
	iceprog $<

sudo-prog: $(PROJ).bin
	@echo 'Executing prog as root!!!'
	sudo iceprog $<

clean:
	rm -f $(PROJ).json $(PROJ).asc $(PROJ).rpt $(PROJ).bin

.SECONDARY:
.PHONY: all prog clean

=== examples/iceblink/Makefile ===
PROJ = example
PIN_DEF = iceblink.pcf
DEVICE = hx1k
PACKAGE = vq100

all: $(PROJ).rpt $(PROJ).bin

%.json: %.v
	yosys -p 'synth_ice40 -top top -json $@' $<

%.asc: $(PIN_DEF) %.json
	nextpnr-ice40 --$(DEVICE) --package $(PACKAGE) --asc $@ --pcf $< --json $*.json

%.bin: %.asc
	icepack $< $@

%.rpt: %.asc
	icetime -d $(DEVICE) -mtr $@ $<

prog: $(PROJ).bin
	iCEburn.py  -e -v -w  $<

sudo-prog: $(PROJ).bin
	@echo 'Executing prog as root!!!'
	iCEburn.py  -e -v -w  $<

clean:
	rm -f $(PROJ).json $(PROJ).asc $(PROJ).rpt $(PROJ).bin

.PHONY: all prog clean

=== examples/icemulti/Makefile ===
all: config.bin

prog: config.bin
	sudo iceprog config.bin

sudo-prog: config.bin
	@echo 'Executing prog as root!!!'
	sudo iceprog config.bin

config.bin: app0.bin app1.bin app2.bin app3.bin
	icemulti -v -A16 -p0 -o config.bin app0.bin app1.bin app2.bin app3.bin

app%.bin: app%.v icestick.pcf
	yosys -p "synth_ice40 -top top -json $(basename $<).json" $<
	nextpnr-ice40 --hx1k --package tq144 --asc $(basename $<).asc --pcf icestick.pcf --json $(basename $<).json
	icetime -d hx1k -c 25 $(basename $<).asc
	icepack $(basename $<).asc $(basename $<).bin

clean:
	rm -f app?.asc app?.bin app?.json config.bin

.PHONY: prog sudo-prog clean

=== examples/icezum/Makefile ===
PROJ = example
PIN_DEF = icezum.pcf
DEVICE = hx1k
PACKAGE = tq144

all: $(PROJ).rpt $(PROJ).bin

%.json: %.v
	yosys -p 'synth_ice40 -top top -json $@' $<

%.asc: $(PIN_DEF) %.json
	nextpnr-ice40 --$(DEVICE) --package $(PACKAGE) --asc $@ --pcf $< --json $*.json

%.bin: %.asc
	icepack $< $@

%.rpt: %.asc
	icetime -d $(DEVICE) -mtr $@ $<

prog: $(PROJ).bin
	iceprog $<

sudo-prog: $(PROJ).bin
	@echo 'Executing prog as root!!!'
	sudo iceprog $<

clean:
	rm -f $(PROJ).json $(PROJ).asc $(PROJ).rpt $(PROJ).bin

.SECONDARY:
.PHONY: all prog clean

=== debian/changelog ===
fpga-icestorm (0~20250207git7fbf8c0+dfsg1-1) unstable; urgency=medium

  * New upstream version 0~20250207git7fbf8c0+dfsg1

 -- Daniel Gröber <dxld@darkboxed.org>  Mon, 17 Mar 2025 23:13:25 +0100

fpga-icestorm (0~20230218gitd20a5e9-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Delegate placement of udev files to pkg-config data (Closes: #1057752)
  * Use debhelper compat 13 for substitutions in .install files

 -- Chris Hofstaedtler <zeha@debian.org>  Fri, 07 Jun 2024 21:10:15 +0200

=== debian/control ===
Source: fpga-icestorm
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Ruben Undheim <ruben.undheim@gmail.com>,
           Daniel Gröber <dxld@darkboxed.org>
Section: electronics
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libftdi-dev,
               python3,
               txt2man,
               pkgconf,
               systemd-dev,
               python3-sphinx,
               python3-sphinx-rtd-theme,
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/electronics-team/fpga-icestorm
Vcs-Git: https://salsa.debian.org/electronics-team/fpga-icestorm.git
Homepage: http://bygone.clairexen.net/icestorm/
Rules-Requires-Root: no

Package: fpga-icestorm-chipdb
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Chip database files for fpga-icestorm
 Project IceStorm aims at documenting the bitstream format of Lattice iCE40
 FPGAs and providing simple tools for analyzing and creating bitstream files.
 .
 The focus of the project is on the iCE40 LP/HX 1K/4K/8K chips. The iCE40
 UltraPlus parts are also supported, including DSPs, oscillators, RGB and
 SPRAM. iCE40 LM, Ultra and UltraLite parts are not yet supported.
 .
 This package contains the chip database files for fpga-icestorm.

Package: fpga-icestorm
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${sphinxdoc:Depends},
         python3
Recommends: yosys,
            fpga-icestorm-chipdb
Built-Using: ${sphinxdoc:Built-Using}
Suggests: nextpnr-ice40 | nextpnr-ice40-qt
Description: Tools to handle the bitstream format of Lattice iCE40 FPGAs
 Project IceStorm aims at documenting the bitstream format of Lattice iCE40
 FPGAs and providing simple tools for analyzing and creating bitstream files.
 .
 The focus of the project is on the iCE40 LP/HX 1K/4K/8K chips. The iCE40
 UltraPlus parts are also supported, including DSPs, oscillators, RGB and
 SPRAM. iCE40 LM, Ultra and UltraLite parts are not yet supported.
 .
 This package contains multiple tools needed to handle the bitstream.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d @$(SOURCE_DATE_EPOCH) +"%d %B %Y")

export CHIPDB_SUBDIR=fpga-icestorm/chipdb

export deb_udevdir = $(shell pkg-config --variable=udevdir udev | sed s,^/,,)

%:
	dh $@ --with sphinxdoc

override_dh_auto_clean:
	dh_auto_clean
	$(RM) debian/man/*.1
	$(RM) -r icebox/__pycache__
	$(RM) -r docs/build
	for dir in examples/*/; do make -C $$dir clean; done

execute_after_dh_auto_build:
	make -C docs html

override_dh_auto_install:
	PREFIX=/usr dh_auto_install

override_dh_install:
	dh_install

        # Note: dh_install will install icebox source files twice, since we
        # can't tell it only to install non-overlapping files in the
        # install file, we fix this up here.
        #
        # Also, on arch:all builds only the chipdb package gets built so
        # the fpga-icestorm directory will be missing.
	if [ -d debian/fpga-icestorm ]; then \
		cd debian/fpga-icestorm/usr/share/fpga-icestorm/python/ && \
		find . -type f -print0 | xargs -0 -n1 -I{} rm ../../../bin/{}; \
	fi

override_dh_installman:
	cd debian/man ; CHANGELOG_DATE="$(CHANGELOG_DATE)" ./genmanpages.sh
	dh_installman

=== debian/watch ===
version=4
opts=mode=git,\
dversionmangle=s/0~(\d{8})git([a-f0-9]{7})@DEB_EXT@/0\.0~git$1\.$2/,\
oversionmangle=s/0\.0~git(\d{8})\.([a-f0-9]{7})$/0~$1git$2/ \
https://github.com/YosysHQ/icestorm.git \
HEAD

## fpga-icestorm 0%7e20160218gitf2b2549

=== Makefile ===
include config.mk

all:
	$(MAKE) -C icebox
	$(MAKE) -C icepack
	$(MAKE) -C iceprog
	$(MAKE) -C icemulti
	$(MAKE) -C icepll
	$(MAKE) -C icetime

clean:
	$(MAKE) -C icebox clean
	$(MAKE) -C icepack clean
	$(MAKE) -C iceprog clean
	$(MAKE) -C icemulti clean
	$(MAKE) -C icepll clean
	$(MAKE) -C icetime clean

install:
	$(MAKE) -C icebox install
	$(MAKE) -C icepack install
	$(MAKE) -C iceprog install
	$(MAKE) -C icemulti install
	$(MAKE) -C icepll install
	$(MAKE) -C icetime install

uninstall:
	$(MAKE) -C icebox uninstall
	$(MAKE) -C icepack uninstall
	$(MAKE) -C iceprog uninstall
	$(MAKE) -C icemulti uninstall
	$(MAKE) -C icepll uninstall
	$(MAKE) -C icetime uninstall

mxebin: clean
	$(MAKE) MXE=1
	rm -rf icestorm-win32 && mkdir icestorm-win32
	cp icebox/chipdb-*.txt icepack/*.exe iceprog/*.exe icestorm-win32/
	cp icemulti/*.exe icepll/*.exe icetime/*.exe icestorm-win32/
	zip -r icestorm-win32.zip icestorm-win32/

.PHONY: all clean install uninstall

=== icepack/Makefile ===
include ../config.mk
LDLIBS = -lm -lstdc++
CXXFLAGS = -MD -O0 -ggdb -Wall -std=c++11 -I/usr/local/include
MXEGCC = /usr/local/src/mxe/usr/bin/i686-pc-mingw32-gcc

all: icepack$(EXE) iceunpack$(EXE)

icepack$(EXE): icepack.o
	$(CC) -o $@ $(LDFLAGS) $^ $(LDLIBS)

iceunpack: icepack
	ln -sf icepack iceunpack

iceunpack.exe:
	# no iceunpack.exe, use icepack -u

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp icepack $(DESTDIR)$(PREFIX)/bin/icepack
	ln -sf icepack $(DESTDIR)$(PREFIX)/bin/iceunpack

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/icepack
	rm -f $(DESTDIR)$(PREFIX)/bin/iceunpack

clean:
	rm -f icepack
	rm -f iceunpack
	rm -f icepack.exe
	rm -f *.o *.d

-include *.d

.PHONY: all install uninstall clean

=== iceprog/Makefile ===
include ../config.mk
LDLIBS = -L/usr/local/lib -lftdi -lm
CFLAGS = -MD -O0 -ggdb -Wall -std=c99 -I/usr/local/include

ifeq ($(MXE),1)
LDLIBS += -lusb
endif

all: iceprog$(EXE)

iceprog$(EXE): iceprog.o
	$(CC) -o $@ $(LDFLAGS) $^ $(LDLIBS)

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp iceprog $(DESTDIR)$(PREFIX)/bin/iceprog

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/iceprog

clean:
	rm -f iceprog
	rm -f iceprog.exe
	rm -f *.o *.d

-include *.d

.PHONY: all install uninstall clean

=== icetime/Makefile ===
include ../config.mk
LDLIBS = -lm -lstdc++
CXXFLAGS = -MD -O0 -ggdb -Wall -std=c++11 -I/usr/local/include -DPREFIX='"$(PREFIX)"'

all: icetime$(EXE)

icetime$(EXE): icetime.o
	$(CC) -o $@ $(LDFLAGS) $^ $(LDLIBS)

icetime.o: icetime.cc timings.inc

timings.inc: timings.py ../icefuzz/timings_*.txt
	python3 timings.py > timings.inc.new
	mv timings.inc.new timings.inc

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp icetime $(DESTDIR)$(PREFIX)/bin/icetime

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/icetime


# View timing netlist:
#  yosys -qp 'read_verilog -lib cells.v; prep; show' test0_ref.v
#  yosys -qp 'read_verilog -lib cells.v; prep; show' test0_out.v

test0 test1 test2 test3 test4 test5 test6 test7 test8 test9: icetime
	test -f $@_ref.v || python3 mktest.py $@
	./icetime -m -d hx1k -P tq144 -p $@.pcf -o $@_out.v $@.asc
	yosys $@.ys

run0 run1 run2 run3 run4 run5 run6 run7 run8 run9: icetime
	./icetime -t -d hx1k -P tq144 -p $(subst run,test,$@).pcf $(subst run,test,$@).asc

show0 show1 show2 show3 show4 show5 show6 show7 show8 show9: icetime
	bash show.sh $(subst show,test,$@)
	xdot $(subst show,test,$@).dot

test: test0 test1 test2 test3 test4 test5 test6 test7 test8 test9

show: show0 show1 show2 show3 show4 show5 show6 show7 show8 show9

clean:
	rm -f icetime icetime.exe timings.inc *.o *.d
	rm -rf test[0-9]*

-include *.d

.PHONY: all install uninstall clean

## fpga-icestorm 1.1

=== docs/source/requirements.txt ===
sphinx
sphinx_rtd_theme 
sphinxcontrib-svg2pdfconverter

=== debian/changelog ===
fpga-icestorm (1.1-1) unstable; urgency=medium

  * New upstream version 1.1
  * Switch to libftdi1-dev (Closes: #1122870)

 -- Daniel Gröber <dxld@darkboxed.org>  Sat, 28 Feb 2026 22:26:18 +0100

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,14 @@
 Section: electronics
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               libftdi-dev,
+               libftdi1-dev,
                python3,
                txt2man,
                pkgconf,
                systemd-dev,
                python3-sphinx,
                python3-sphinx-rtd-theme,
+               python3-sphinxcontrib.svg2pdfconverter,
 Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/electronics-team/fpga-icestorm
 Vcs-Git: https://salsa.debian.org/electronics-team/fpga-icestorm.git

=== debian/tests/control ===
Tests: can-show-help
Depends: @
Restrictions: superficial

Tests: examples-compile
Depends: @, make, yosys, nextpnr-ice40
Restrictions: rw-build-tree allow-stderr
Architecture: !s390x

=== debian/watch ===
version=4
https://github.com/YosysHQ/icestorm/tags .*/v?(\d.*)@ARCHIVE_EXT@

#version=4
#opts=mode=git,\
#dversionmangle=s/1.1+(\d{8})git([a-f0-9]{7})@DEB_EXT@/0\.0~git$1\.$2/,\
#oversionmangle=s/1\.1+git(\d{8})\.([a-f0-9]{7})$/0~$1git$2/ \
#https://github.com/YosysHQ/icestorm.git \
#HEAD
